DisplayOverviewHud = {};

DisplayOverviewHud.metadata = {
	interface = " FS19 1.x",
	title = " DisplayOverviewHud",
	notes = " Zeight eine Übersicht der Lagerbestände/Animals und Preise/Bestpreise",
	author = " (by HappyLooser)",
	version = " v0.9 Beta",
	datum = " 20.11.2018",
	update = " 06.01.2019",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

--update
--fix large number(99.87868...),txtSize not loaded XML
--new 

DisplayOverviewHud.modDir = g_currentModDirectory;
function DisplayOverviewHud:loadMap(name)
	g_currentMission.DisplayOverviewHud = DisplayOverviewHud;	
	print("---loading".. tostring(DisplayOverviewHud.metadata.title).. tostring(DisplayOverviewHud.metadata.version).. tostring(DisplayOverviewHud.metadata.author).. "---")
	if isServer() then return;end;
	DisplayOverviewHud.isLoadMap = false;
	DisplayOverviewHud.settings = {isOn=true,isHidden=false,isLoadOverlays=false,size=0.010,txtBold=true,onlyAppearsOnStats=true,modusInfo=true,supportForAnimalsHud=true,firstCheckForeignAnimalsHudValues=false,isForeignAnimalsHud=false,foreignAnimalsHud={},foreignAnimalsHudDefault={}};
	DisplayOverviewHud.settings.notDrawFillTypes = {};	
	DisplayOverviewHud.settings.draw = {
		width = {fillTypesT=0,amountsT=0,stationsT=0,bestPricesT=0,foreignAnimalsHudT=0,animalsNT=0,animalsST=0,animals={}},
		height = {first=0, maxT=0,animals={}},
		--posSequenceX = {};
		sequenceModusMax = 30,
		sequenceModus = {};		
		sequenceSplit = {};
		animalModusSideBySide = true;
		animalModusEveryAlone = true;
		modus = 1,
		maxModus = 6,
		minStationNameLength = 9;
		maxStationNameLength = 20;
		maxFillNameLength = 20;
		lineFat = 0.0006, --not edit pls LS19 Bug !?!		
		widthDif = 0.005, --not edit pls LS19 Bug !?!
		seeLine = true,
		buttonGfxWidth1 = DisplayOverviewHud:pxToNormal(1, 'x', false),
		buttonGfxHeight1  = DisplayOverviewHud:pxToNormal(1, 'y', false),
		lineWho = {fillTypesHorizontal=true,fillTypesVertical=true,amountsHorizontal=true,amountsVertical=true,bestPricesHorizontal=true,bestPricesVertical=true,bestPrices=true,stationsHorizontal=true,stationsVertical=false,animalsHorizontal=true}
	};	
	DisplayOverviewHud.color = {
		backgroundFillTypes = { 0, 0, 0, 0.50 }, --black
		backgroundStations = { 0, 0, 0, 0.50 }, --black
		backgroundAmounts = { 0, 0, 0, 0.50 }, --black
		backgroundBestPrices = { 0, 0, 0, 0.50 }, --black
		backgroundAnimals = { 0, 0, 0, 0.50 }, --black
		lineFillTypes = { 1, 1, 1, 0.60 }, --white
		lineStations = { 1, 1, 1, 0.60 }, --white
		lineAmounts = { 1, 1, 1, 0.60 }, --white
		lineBestPrices = { 1, 1, 1, 0.60 }, --white
		lineAnimals = { 1, 1, 1, 0.60 }, --white
		greatDemand = { 0/255, 255/255, 255/255, 1.00 }, --ls15
		bestPrice = { 0/255, 100/255,  0/255, 1.00 }, --darkGreen --stations
		bestPriceUp = { 0/255, 100/255,  0/255, 1.00 }, --green --stations
		bestPriceDown = {116/255, 0/255,0/255, 1.00 }, --closeRed --stations
		txtDefault = { 1, 1, 1, 1 }, --white
		txtStation = { 1, 1, 1, 1 }, --white
		txtFillType = { 1, 1, 1, 1 }, --white
		txtAnimal = { 1, 1, 1, 1 }, --white
		txtBestPrice = { 255/255, 165/255, 0/255, 1.00 }, --orange --bestPrices
		txtAmount = { 1, 1, 0, 1}, --yellow
		txtNotAmount = { 1, 1, 1, 0.70 }, --white --inactive
		prozent = {	{255/255, 	255/255, 	255/255,	1.00 }, --white
					{  0/255,	255/255, 	  0/255, 	1.00 }, --green
					{154/255, 	205/255,  	 50/255,	1.00 }, --yellowGreen
					{255/255, 	255/255, 	  0/255, 	1.00 }, --yellow
					{255/255, 	 65/255, 	  0/255, 	1.00 }, --orange
					{255/255,   28/255,   	  0/255, 	1.00 }, --orangeRed
					{255/255,	  0/255, 	  0/255, 	1.00 } --red
		}			
	};	
	DisplayOverviewHud.settingsDir = getUserProfileAppPath().. "modsSettings/DisplayOverviewHud/";	
	DisplayOverviewHud.rebootXml = false;
	DisplayOverviewHud.hlDebugMode = false;
	DisplayOverviewHud.bale = {round=0,square=0};
	DisplayOverviewHud:init();
	source(DisplayOverviewHud.modDir.."XmlSettings.lua");
	source(DisplayOverviewHud.modDir.."animalsModul.lua");
	DisplayOverviewHud.inGameDisplays = {};	
	DisplayOverviewHud:setGetCfg(true);
	DisplayOverviewHud.settings.isLoadOverlays = DisplayOverviewHud:loadOverlays();
	if #DisplayOverviewHud.settings.draw.sequenceModus == 0 then
		DisplayOverviewHud.settings.draw.sequenceModus[1] = "fillTypes amounts";
		DisplayOverviewHud.settings.draw.sequenceModus[2] = "bestPrices fillTypes amounts stations";
		DisplayOverviewHud.settings.draw.sequenceModus[3] = "fillTypes bestPrices amounts";
	end;
	if DisplayOverviewHud.settings.notDrawFillTypes.animals == nil then
		DisplayOverviewHud.settings.notDrawFillTypes.animals = {"horse_type", "cow_type", "sheep_type", "chicken_type", "pig_type"};
	end;
	if DisplayOverviewHud.settings.notDrawFillTypes.default == nil then
		DisplayOverviewHud.settings.notDrawFillTypes.default = {"unknown", "air", "def", "tarp", "treesaplings", "diesel", "fuel", "roundbale_", "squarebale_"};
	end;
	if DisplayOverviewHud.settings.notDrawFillTypes.byUser == nil then
		DisplayOverviewHud.settings.notDrawFillTypes.byUser = {"weed", "poplar"};
	end;
	if DisplayOverviewHud.settings.notDrawFillTypes.exactNames == nil then
		DisplayOverviewHud.settings.notDrawFillTypes.exactNames = {"grass", "drygrass"};
	end;
	if DisplayOverviewHud.settings.notDrawFillTypes.masterNameForExactNames == nil then
		DisplayOverviewHud.settings.notDrawFillTypes.masterNameForExactNames = {"grass"};
	end;
end;

function DisplayOverviewHud:deleteMap()
	if isServer() then return;end;
	DisplayOverviewHud:setGetCfg(false);DisplayOverviewHud:deleteOverlays();	
end;

function DisplayOverviewHud:mouseEvent(posX, posY, isDown, isUp, button)
end;

function DisplayOverviewHud:keyEvent(unicode, sym, modifier, isDown)
	if isServer() then return;end;	
	if DisplayOverviewHud:get_hl("getIngameMap", {}, "getIngameMap") or DisplayOverviewHud:get_hl("getFullSize", {true, false}, "getFullSize") then return;end;
	if DisplayOverviewHud.rebootXml and DisplayOverviewHud:get_hl("getFullSize", {false, true}, "getFullSize") and Input.isKeyPressed(Input.KEY_esc) then
		DisplayOverviewHud:setGetCfg(true);	
	end;
	if Input.isKeyPressed(Input[g_inputBinding.nameActions["DOHud"].primaryKeyboardInput]) then
		if DisplayOverviewHud.settings.isOn then DisplayOverviewHud.settings.isOn = false;else DisplayOverviewHud.settings.isOn = true;DisplayOverviewHud:loadPlaceables();DisplayOverviewHud:loadAnimales();end;	
		if DisplayOverviewHud.settings.modusInfo then
			if DisplayOverviewHud.settings.isOn then g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, "DOHud ON", "DOonOff");g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_OK, "DOHud Load Placeables New", "DOon");
			else g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_CRITICAL, "DOHud OFF", "DOoff", nil, 100);end;
			--testen hideTopNotification(DOoff)
		end;
		return;
	end;
	if DisplayOverviewHud.settings.isOn then
		if Input.isKeyPressed(Input[g_inputBinding.nameActions["DOHudMasterKey"].primaryKeyboardInput]) and Input.isKeyPressed(Input[g_inputBinding.nameActions["DOHudSlaveKeyModusRight"].primaryKeyboardInput])then
			local tempModus = DisplayOverviewHud.settings.draw.modus+1;if tempModus > DisplayOverviewHud.settings.draw.maxModus then tempModus = 1;end;DisplayOverviewHud.settings.draw.modus = tempModus;			
			if DisplayOverviewHud.settings.modusInfo then
				if DisplayOverviewHud.settings.draw.sequenceModus[DisplayOverviewHud.settings.draw.modus] ~= nil and type(DisplayOverviewHud.settings.draw.sequenceModus[DisplayOverviewHud.settings.draw.modus]) == "string" then
					g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_INFO, "DOHud Modus ".. tostring(DisplayOverviewHud.settings.draw.modus).. ": ".. tostring(DisplayOverviewHud.settings.draw.sequenceModus[DisplayOverviewHud.settings.draw.modus]), "DOmodus");
				else
					g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_CRITICAL, "DOHud Modus ".. tostring(DisplayOverviewHud.settings.draw.modus).. ": UNKNOWN or EMPTY", "DOmodus");
				end;
			end;
			return;
		end;
		if Input.isKeyPressed(Input[g_inputBinding.nameActions["DOHudMasterKey"].primaryKeyboardInput]) and Input.isKeyPressed(Input[g_inputBinding.nameActions["DOHudSlaveKeyModusLeft"].primaryKeyboardInput])then
			local tempModus = DisplayOverviewHud.settings.draw.modus-1;if tempModus <= 0 then tempModus = DisplayOverviewHud.settings.draw.maxModus;end;DisplayOverviewHud.settings.draw.modus = tempModus;
			if DisplayOverviewHud.settings.modusInfo then
				if DisplayOverviewHud.settings.draw.sequenceModus[DisplayOverviewHud.settings.draw.modus] ~= nil and type(DisplayOverviewHud.settings.draw.sequenceModus[DisplayOverviewHud.settings.draw.modus]) == "string" then
					g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_INFO, "DOHud Modus ".. tostring(DisplayOverviewHud.settings.draw.modus).. ": ".. tostring(DisplayOverviewHud.settings.draw.sequenceModus[DisplayOverviewHud.settings.draw.modus]), "DOmodus");
				else
					g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_CRITICAL, "DOHud Modus ".. tostring(DisplayOverviewHud.settings.draw.modus).. ": UNKNOWN or EMPTY", "DOmodus");
				end;
			end;
			return;
		end;
		if DisplayOverviewHud.hlDebugMode and not DisplayOverviewHud:get_hl("getFullSize", {true, true}, "getFullSize") and Input.isKeyPressed(Input.KEY_f2)then		
			if g_currentMission.hl.debug ~= nil then
				local a=1;		
				for key,value in pairs(g_currentMission.hl.debug) do
					for key1,value1 in pairs(value) do			
						print(tostring(a).. ".hl_Debug Error at ".. tostring(key).. " = ".. tostring(value1))			
						a=a+1;
					end;
				end;
			else
				print("1.hl_Debug NOT Found Error at ".. tostring(DisplayOverviewHud.metadata.title))
			end;
			
		end;
	end;
end;

function DisplayOverviewHud:update(dt)	
	if isServer() then return;end;
	if not DisplayOverviewHud.isLoadMap then
		DisplayOverviewHud.isLoadMap = true;
		DisplayOverviewHud:loadFillTypes();
		DisplayOverviewHud:loadPlaceables();
		DisplayOverviewHud:loadAnimales();
		searchForeignMods();
		getInGameDisplays();		
	end;
end;

function DisplayOverviewHud:draw()
	if isServer() then return;end;
	if g_currentMission.hl.getIngameMap() or g_currentMission.hl.getFullSize(true, true) then return;end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
	if DisplayOverviewHud.settings.isOn then
		if DisplayOverviewHud.settings.draw.modus == 1 or 2 or 3 then
			drawFillTypeName = {};
			drawAmountFillType = {};		
			drawStationName = {};
			drawAnimalType = {};
			drawForeignAnimalsHud = {};
			drawAmountsItems = {};
			--drawBestPriceStation = {};
			DisplayOverviewHud:resetWidthHeightT();
			local getSequence = DisplayOverviewHud.settings.draw.sequenceModus[DisplayOverviewHud.settings.draw.modus];
			if getSequence ~= nil then
				DisplayOverviewHud:getDrawModus(getSequence, true, true);
				DisplayOverviewHud:setDrawModus();			
			end;			
		end;
	end;	
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;

function DisplayOverviewHud:init()
	source(DisplayOverviewHud.modDir.."_hl.lua");
end;
addModEventListener(DisplayOverviewHud);

function DisplayOverviewHud:setDrawModus()
	local posY = DisplayOverviewHud:getRightPosY()-DisplayOverviewHud.settings.draw.height.first;
	local posX = 1.0;
	local size = DisplayOverviewHud.settings.size;
	local txtHeightFirst = DisplayOverviewHud.settings.draw.height.first;
	local heightDistance = getTextHeight(size, "Ä_")/2;	
	local widthDif = DisplayOverviewHud.settings.draw.widthDif;
	local lineFat = DisplayOverviewHud.settings.draw.lineFat;
	local isOverlays = DisplayOverviewHud.settings.isLoadOverlays;
	function fillTypesVirtual()
		if #drawFillTypeName > 0 then
			local fillTypeNamePosY = posY;
			for a=1, #drawFillTypeName do
				fillTypeNamePosY = fillTypeNamePosY-drawFillTypeName[a].txtHeight;
				DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].drawPosY = fillTypeNamePosY;
				DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].isDraw = true;
			end;
		end;
	end;	
	function amounts(pos)
		if #drawAmountFillType > 0 then
			if isOverlays then DisplayOverviewHud.overlays["groundAmounts"]:render();end;			
			local amountPosX = posX-getFixPosX(pos);
			local amountPosY = posY;
			local amountHeight = 0;						
			setTextColor(unpack(DisplayOverviewHud.color.txtAmount));
			for fillType,fillLevel in pairs(drawAmountFillType) do
				local isAmount = Utils.getNoNil(fillLevel.amount, 0)
				if isAmount > 0 then
					local amount = string.format("%1.0f", "".. isAmount);
					local amountWidthTemp = getTextWidth(size, amount);					
					setTextBold(DisplayOverviewHud.settings.txtBold);
					renderText(amountPosX+DisplayOverviewHud.settings.draw.width.amountsT-amountWidthTemp-(widthDif/2), DisplayOverviewHud.fillTypes[fillType].drawPosY, size, tostring(amount));
				end;
			end;
			if isOverlays then
				DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["groundAmounts"], amountPosX,amountPosY-(txtHeightFirst/2)-DisplayOverviewHud.settings.draw.height.maxT,DisplayOverviewHud.settings.draw.width.amountsT,DisplayOverviewHud.settings.draw.height.maxT+(txtHeightFirst)}, "setOverlay Background Amounts");
				if DisplayOverviewHud.settings.draw.seeLine then
					if DisplayOverviewHud.settings.draw.lineWho.amountsHorizontal then	
						for key,desc in pairs(DisplayOverviewHud.fillTypes) do							
							if DisplayOverviewHud.fillTypes[desc.descIndex].isDraw and DisplayOverviewHud.fillTypes[desc.descIndex].drawPosY ~= nil then
								DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineAmounts"], DisplayOverviewHud.overlays["groundAmounts"].x,DisplayOverviewHud.fillTypes[desc.descIndex].drawPosY-(heightDistance/2),DisplayOverviewHud.overlays["groundAmounts"].width,lineFat}, "setOverlay Background Line Amounts/FillTypes horizontal");
								DisplayOverviewHud.overlays["lineAmounts"]:render();
							end;
						end;
					end;
					if DisplayOverviewHud.settings.draw.lineWho.amountsVertical then
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineAmounts"], DisplayOverviewHud.overlays["groundAmounts"].x,DisplayOverviewHud.overlays["groundAmounts"].y,lineFat,DisplayOverviewHud.overlays["groundAmounts"].height}, "setOverlay Background Line Amounts vertical first");
						DisplayOverviewHud.overlays["lineAmounts"]:render();
					end;
				end;
			end;
		end;
	end;
	function fillTypes(pos)
		if #drawFillTypeName > 0 then
			if isOverlays then DisplayOverviewHud.overlays["groundFillTypes"]:render();end;
			local fillTypeNamePosX = posX-getFixPosX(pos); 
			local fillTypeNamePosY = posY;
			for a=1, #drawFillTypeName do						
				setTextColor(unpack(drawFillTypeName[a].txtColor));				
				local isAmount = false;
				if drawAmountFillType[drawFillTypeName[a].descIndex] ~= nil and Utils.getNoNil(drawAmountFillType[drawFillTypeName[a].descIndex].amount, 0) > 0 then isAmount=true;end;
				setTextBold(DisplayOverviewHud.settings.txtBold and isAmount);
				fillTypeNamePosY = fillTypeNamePosY-drawFillTypeName[a].txtHeight;				
				renderText(fillTypeNamePosX+(widthDif/2), fillTypeNamePosY, size, drawFillTypeName[a].txt);
				if isOverlays and DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.lineWho.fillTypesHorizontal then
					DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineFillTypes"], fillTypeNamePosX,fillTypeNamePosY-(heightDistance/2),DisplayOverviewHud.settings.draw.width.fillTypesT,lineFat}, "setOverlay line FillType horizontal");
					DisplayOverviewHud.overlays["lineFillTypes"]:render();
				end;
			end;			
			if isOverlays then
				DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["groundFillTypes"], fillTypeNamePosX,fillTypeNamePosY-(txtHeightFirst/2),DisplayOverviewHud.settings.draw.width.fillTypesT,DisplayOverviewHud.settings.draw.height.maxT+(txtHeightFirst)}, "setOverlay Background FillType");
				if DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.lineWho.fillTypesVertical then
					DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineFillTypes"], DisplayOverviewHud.overlays["groundFillTypes"].x,DisplayOverviewHud.overlays["groundFillTypes"].y,lineFat,DisplayOverviewHud.overlays["groundFillTypes"].height}, "setOverlay Background Line FillTypes vertical first");
					DisplayOverviewHud.overlays["lineFillTypes"]:render();
				end;
			end;
		end;
	end;
	function bestPrices(pos)
		if #drawFillTypeName > 0 then
			if isOverlays then DisplayOverviewHud.overlays["groundBestPrices"]:render();end;			 
			local bestPriceStationPosX = posX-getFixPosX(pos);
			local bestPriceStationPosY = posY;
			for a=1, #drawFillTypeName do
				setTextColor(unpack(DisplayOverviewHud.color.txtBestPrice));
				local isAmount = false;
				if drawAmountFillType[drawFillTypeName[a].descIndex] ~= nil and Utils.getNoNil(drawAmountFillType[drawFillTypeName[a].descIndex].amount, 0) > 0 then isAmount=true;end;
				setTextBold(DisplayOverviewHud.settings.txtBold and isAmount);
				if DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex] ~= nil and DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].isDraw then
					if DisplayOverviewHud.greatDemandFillTypes ~= nil and DisplayOverviewHud.greatDemandFillTypes[drawFillTypeName[a].descIndex] ~= nil and DisplayOverviewHud.greatDemandFillTypes[drawFillTypeName[a].descIndex].stationName == DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].bestPriceStation then
						setTextColor(unpack(DisplayOverviewHud.color.greatDemand));
					end;
					renderText(bestPriceStationPosX+(widthDif/2), DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].drawPosY, size, DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].bestPriceStation);
					if isOverlays and DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.lineWho.bestPricesHorizontal then
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineBestPrices"], bestPriceStationPosX,DisplayOverviewHud.fillTypes[drawFillTypeName[a].descIndex].drawPosY-(heightDistance/2),DisplayOverviewHud.settings.draw.width.bestPricesT,lineFat}, "setOverlay line BestPrices horizontal");
						DisplayOverviewHud.overlays["lineBestPrices"]:render();
					end;
				end;
			end;
			if isOverlays then
				DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["groundBestPrices"], bestPriceStationPosX,bestPriceStationPosY-(txtHeightFirst/2)-DisplayOverviewHud.settings.draw.height.maxT,DisplayOverviewHud.settings.draw.width.bestPricesT,DisplayOverviewHud.settings.draw.height.maxT+(txtHeightFirst)}, "setOverlay Background BestPrices");
				if DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.lineWho.bestPricesVertical then
					DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineBestPrices"], DisplayOverviewHud.overlays["groundBestPrices"].x,DisplayOverviewHud.overlays["groundBestPrices"].y,lineFat,DisplayOverviewHud.overlays["groundBestPrices"].height}, "setOverlay Background Line BestPrices vertical first");
					DisplayOverviewHud.overlays["lineBestPrices"]:render();
				end;
			end;
		end;	
	end;	
	function stations(pos)
		if #drawStationName > 0 then
			if isOverlays then DisplayOverviewHud.overlays["groundStations"]:render();end;
			local stationNamePosX = posX-getFixPosX(pos);
			local stationNamePosY = posY;			
			local stationNameWidth = 0;					
			for a=1, #drawStationName do
				setTextColor(unpack(drawStationName[a].txtColor));
				setTextBold(DisplayOverviewHud.settings.txtBold);
				renderText(stationNamePosX+(widthDif/2)+stationNameWidth, stationNamePosY, size, drawStationName[a].txt);						
				drawStationName[a].drawPosX = stationNamePosX+(widthDif/2)+stationNameWidth;
				local sellingStation = DisplayOverviewHud.sellStations[drawStationName[a].descIndex].object.sellingStation;
				if sellingStation ~= nil then
					for fillType,isAccepted in pairs(sellingStation.acceptedFillTypes) do
						if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil and DisplayOverviewHud.fillTypes[fillType].isDraw then
							setTextColor(unpack(DisplayOverviewHud.color.txtStation));									
							local difficultyMultiplier = 1000;
							local multiplier = getMultiplier();
							--if DisplayOverviewHud.fillTypes[fillType].descName == "EGG" then difficultyMultiplier = 1;end;
							local pricePerLiter = ((sellingStation.fillTypePrices[fillType]+sellingStation.fillTypePriceRandomDelta[fillType])*sellingStation.priceMultipliers[fillType]*multiplier)*difficultyMultiplier;
							if pricePerLiter >= DisplayOverviewHud.fillTypes[fillType].bestPrice then setTextColor(unpack(DisplayOverviewHud.color.bestPrice));end;
							local fillTypePrice = g_i18n:formatMoney(pricePerLiter);
							if DisplayOverviewHud.greatDemandFillTypes ~= nil and DisplayOverviewHud.greatDemandFillTypes[fillType] ~= nil and DisplayOverviewHud.greatDemandFillTypes[fillType].stationName == drawStationName[a].txt then
								setTextColor(unpack(DisplayOverviewHud.color.greatDemand));
							end;									
							local isAmount = false;
							if drawAmountFillType[fillType] ~= nil and Utils.getNoNil(drawAmountFillType[fillType].amount, 0) > 0 then isAmount=true;end;
							setTextBold(DisplayOverviewHud.settings.txtBold and isAmount);
							setTextAlignment(1);
							renderText(stationNamePosX+(widthDif/2)+(stationNameWidth)+(drawStationName[a].txtWidth/2), DisplayOverviewHud.fillTypes[fillType].drawPosY, size, tostring(fillTypePrice));
							setTextAlignment(0);									
							local priceDynamicsIcon = "priceEqual"
							local priceDynamics = sellingStation:getCurrentPricingTrend(fillType)
							--later check mulipliers for Top FillTypes
							--if DisplayOverviewHud.fillTypes[fillType].descName == "COTTON" then priceDynamics = priceDynamics/3;end;
							--if DisplayOverviewHud.fillTypes[fillType].descName == "WOOL" then priceDynamics = priceDynamics/4;end;							
							--local dynamics = "";
							if priceDynamics == 4 then priceDynamicsIcon = "priceUp";elseif priceDynamics == 2 then priceDynamicsIcon = "priceDown";end;									
							--renderText(stationNamePosX+(widthDif/2.2)+(stationNameWidth), DisplayOverviewHud.fillTypes[fillType].drawPosY, size, tostring(priceDynamics));
							if priceDynamics == 2 or priceDynamics == 4 then
								DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays[priceDynamicsIcon], drawStationName[a].drawPosX,DisplayOverviewHud.fillTypes[fillType].drawPosY+(DisplayOverviewHud.fillTypes[fillType].drawTxtHeight/7),DisplayOverviewHud.fillTypes[fillType].drawTxtHeight/3.8,DisplayOverviewHud.fillTypes[fillType].drawTxtHeight/2.2}, "setOverlay ".. tostring(priceDynamicsIcon).. " FillType StationName");
								DisplayOverviewHud.overlays[priceDynamicsIcon]:render();
							end;
						end;
					end;
				end;
				if isOverlays and DisplayOverviewHud.settings.draw.seeLine then
					if DisplayOverviewHud.settings.draw.lineWho.stationsVertical then
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x+stationNameWidth,DisplayOverviewHud.overlays["groundStations"].y,lineFat,DisplayOverviewHud.overlays["groundStations"].height}, "setOverlay Background Line Stations vertical");
						DisplayOverviewHud.overlays["lineStations"]:render();
					else
						DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x+stationNameWidth,stationNamePosY,lineFat,txtHeightFirst/2}, "setOverlay Background Line Stations vertical");
						DisplayOverviewHud.overlays["lineStations"]:render();
					end;
				end;
				stationNameWidth = stationNameWidth+drawStationName[a].txtWidth;
			end;																														
			if isOverlays then 
				DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["groundStations"], stationNamePosX,stationNamePosY-(txtHeightFirst/2)-DisplayOverviewHud.settings.draw.height.maxT,stationNameWidth,DisplayOverviewHud.settings.draw.height.maxT+(txtHeightFirst)}, "setOverlay Background Stations");
				DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x,stationNamePosY-(heightDistance/2),DisplayOverviewHud.overlays["groundStations"].width,lineFat}, "setOverlay Background Line Stations horizontal first StationName");
				DisplayOverviewHud.overlays["lineStations"]:render();
					
				if DisplayOverviewHud.settings.draw.seeLine then					
					if DisplayOverviewHud.settings.draw.lineWho.stationsHorizontal then
						for key,desc in pairs(DisplayOverviewHud.fillTypes) do
							if DisplayOverviewHud.fillTypes[desc.descIndex].isDraw and DisplayOverviewHud.fillTypes[desc.descIndex].drawPosY ~= nil then																	
								DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x,DisplayOverviewHud.fillTypes[desc.descIndex].drawPosY-(heightDistance/2),DisplayOverviewHud.overlays["groundStations"].width,lineFat}, "setOverlay Background Line Stations/FillTypes horizontal");
								DisplayOverviewHud.overlays["lineStations"]:render();
							end;
						end;
					end;
					DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x+DisplayOverviewHud.overlays["groundStations"].width,DisplayOverviewHud.overlays["groundStations"].y,lineFat,DisplayOverviewHud.overlays["groundStations"].height}, "setOverlay Background Line Stations vertical end");
					DisplayOverviewHud.overlays["lineStations"]:render();
					DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.overlays["groundStations"].x,DisplayOverviewHud.overlays["groundStations"].y,lineFat,DisplayOverviewHud.overlays["groundStations"].height}, "setOverlay Background Line Stations vertical first");
					DisplayOverviewHud.overlays["lineStations"]:render();
				end;
			end;
		end;	
	end;	
	local isAnimalsDraw = false;
	function animal(pos, animalName)		
		if isAnimalsDraw then return;end;
		if #drawAnimalType > 0 then
			if not DisplayOverviewHud.settings.draw.animalModusSideBySide then isAnimalsDraw = true;end;
			local animalPosY = posY;					
			local txtHeight = 0;			
			for a=1, #drawAnimalType do				
				if (DisplayOverviewHud.settings.draw.animalModusSideBySide and animalName:lower() == drawAnimalType[a].animalName) or isAnimalsDraw then
					local isEveryAlone = DisplayOverviewHud.settings.draw.animalModusEveryAlone;					
					if (not isEveryAlone and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw <= DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].multiply) or isEveryAlone then 
						local animalPosX = posX-getFixPosX(pos, drawAnimalType[a].animalName);				
						local totalWidth = DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].sT+(DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].nT*DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].multiply);
						local lineAsStringST = getLineAsString(size, DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].sT);	
						local lineAsStringSThalf = getLineAsString(size, DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].sT/2);
						local lineAsStringNT = getLineAsString(size, DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].nT*DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].multiply);
						if isOverlays and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw == 1 then 
							DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["groundAnimals"], animalPosX,animalPosY-DisplayOverviewHud.settings.draw.height.animals[drawAnimalType[a].animalName][1],totalWidth,DisplayOverviewHud.settings.draw.height.animals[drawAnimalType[a].animalName][1]+(txtHeightFirst/2)}, "setOverlay Background Animals");
							DisplayOverviewHud.overlays["groundAnimals"]:render();
							setTextColor(unpack(DisplayOverviewHud.color.lineAnimals));
							renderText(DisplayOverviewHud.overlays["groundAnimals"].x, DisplayOverviewHud.overlays["groundAnimals"].y+DisplayOverviewHud.overlays["groundAnimals"].height, size, tostring(lineAsStringST).. tostring(lineAsStringNT));	
							renderText(DisplayOverviewHud.overlays["groundAnimals"].x, DisplayOverviewHud.overlays["groundAnimals"].y, size, tostring(lineAsStringST).. tostring(lineAsStringNT));	
							
							--DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineAnimals"], DisplayOverviewHud.overlays["groundAnimals"].x,DisplayOverviewHud.overlays["groundAnimals"].y+DisplayOverviewHud.overlays["groundAnimals"].height,DisplayOverviewHud.overlays["groundAnimals"].width,lineFat}, "setOverlay Line Top Horizontal Animals");
							--DisplayOverviewHud.overlays["lineAnimals"]:render();
							--DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineAnimals"], DisplayOverviewHud.overlays["groundAnimals"].x,DisplayOverviewHud.overlays["groundAnimals"].y,DisplayOverviewHud.overlays["groundAnimals"].width,lineFat}, "setOverlay Line End Horizontal Animals");
							--DisplayOverviewHud.overlays["lineAnimals"]:render();
							DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineAnimals"], DisplayOverviewHud.overlays["groundAnimals"].x,DisplayOverviewHud.overlays["groundAnimals"].y,lineFat,DisplayOverviewHud.overlays["groundAnimals"].height}, "setOverlay Line First Vertical Animals");
							DisplayOverviewHud.overlays["lineAnimals"]:render();
							--DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineAnimals"], DisplayOverviewHud.overlays["groundAnimals"].x+DisplayOverviewHud.overlays["groundAnimals"].width,DisplayOverviewHud.overlays["groundAnimals"].y,lineFat,DisplayOverviewHud.overlays["groundAnimals"].height}, "setOverlay Line End Input Vertical Animals");
							--DisplayOverviewHud.overlays["lineAnimals"]:render();
							DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineAnimals"], DisplayOverviewHud.overlays["groundAnimals"].x+DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].sT,DisplayOverviewHud.overlays["groundAnimals"].y,lineFat,DisplayOverviewHud.overlays["groundAnimals"].height}, "setOverlay Line End Output Vertical Animals");
							DisplayOverviewHud.overlays["lineAnimals"]:render();
						end;
						if not isEveryAlone then --and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw > 1 then
							totalWidth = DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].sT+(DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].nT*DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw);
							if DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw == 1 then DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].firstPosY = animalPosY;end;
							if DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw > 1 then animalPosY = DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].firstPosY;end;
						end;
						setTextBold(DisplayOverviewHud.settings.txtBold);					
						if drawAnimalType[a].output ~= nil and #drawAnimalType[a].output > 0 then					
							for i=1, #drawAnimalType[a].output do
								setTextColor(unpack(DisplayOverviewHud.color.txtAnimal));
								if drawAnimalType[a].output[i][3] > 0 then setTextColor(unpack(DisplayOverviewHud.color.prozent[drawAnimalType[a].output[i][3]]));end;
								if isEveryAlone or (not isEveryAlone and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw == 1) then
									renderText(animalPosX+(widthDif/2), animalPosY, size, tostring(drawAnimalType[a].output[i][1]));
								end;
								setTextColor(unpack(DisplayOverviewHud.color.txtAnimal));
								if drawAnimalType[a].output[i][4] > 0 then setTextColor(unpack(DisplayOverviewHud.color.prozent[drawAnimalType[a].output[i][4]]));end;							
								renderText(animalPosX+(widthDif)+totalWidth-drawAnimalType[a].output[i][7], animalPosY, size, tostring(drawAnimalType[a].output[i][2]));							
								if i == 1 and isOverlays and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw == 1 then
									setTextColor(unpack(DisplayOverviewHud.color.lineAnimals));
									renderText(animalPosX, animalPosY-(heightDistance/2), size, tostring(lineAsStringST).. tostring(lineAsStringNT));
								end;
								if i == #drawAnimalType[a].output and isOverlays and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw == 1 then							
									setTextColor(unpack(DisplayOverviewHud.color.lineAnimals));
									renderText(animalPosX, animalPosY-(heightDistance/2), size, tostring(lineAsStringSThalf));													
								end;
								if isOverlays and DisplayOverviewHud.settings.draw.seeLine and i > 1 and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw == 1 then
									setTextColor(unpack(DisplayOverviewHud.color.lineAnimals));
									renderText(animalPosX+DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].sT, animalPosY-(heightDistance/2), size, tostring(lineAsStringNT));
								end;
								if i < #drawAnimalType[a].output or (i == #drawAnimalType[a].output and drawAnimalType[a].input ~= nil and #drawAnimalType[a].input > 0) then						
									animalPosY = animalPosY-drawAnimalType[a].output[i][8];						
								end;
								txtHeight = txtHeight+drawAnimalType[a].output[i][8]						
							end;
						end;				
						if drawAnimalType[a].input ~= nil and #drawAnimalType[a].input > 0 then
							for i=1, #drawAnimalType[a].input do
								setTextColor(unpack(DisplayOverviewHud.color.txtAnimal));
								if drawAnimalType[a].input[i][3] > 0 then setTextColor(unpack(DisplayOverviewHud.color.prozent[drawAnimalType[a].input[i][3]]));end;
								if isEveryAlone or (not isEveryAlone and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw == 1) then
									renderText(animalPosX+(widthDif/2), animalPosY, size, tostring(drawAnimalType[a].input[i][1]));
								end;
								setTextColor(unpack(DisplayOverviewHud.color.txtAnimal));
								if drawAnimalType[a].input[i][4] > 0 then setTextColor(unpack(DisplayOverviewHud.color.prozent[drawAnimalType[a].input[i][4]]));end;
								renderText(animalPosX+(widthDif)+totalWidth-drawAnimalType[a].input[i][7], animalPosY, size, tostring(drawAnimalType[a].input[i][2]));						
								if isOverlays and DisplayOverviewHud.settings.draw.seeLine and DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw == 1 then
									setTextColor(unpack(DisplayOverviewHud.color.lineAnimals));
									renderText(animalPosX+DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].sT, animalPosY-(heightDistance/2), size, tostring(lineAsStringNT));
								end;
								if isOverlays and i == 1 then
									DisplayOverviewHud:get_hl("setOverlay", {DisplayOverviewHud.overlays["lineAnimals"], DisplayOverviewHud.overlays["groundAnimals"].x+totalWidth,DisplayOverviewHud.overlays["groundAnimals"].y,lineFat,DisplayOverviewHud.overlays["groundAnimals"].height}, "setOverlay Line Input not EverlyAlone Vertical Animals");
									DisplayOverviewHud.overlays["lineAnimals"]:render();
								end;
								if i < #drawAnimalType[a].input then						
									animalPosY = animalPosY-drawAnimalType[a].input[i][8];
								end;
								txtHeight = txtHeight+drawAnimalType[a].input[i][8];						
							end;
						end;						
						animalPosY = animalPosY-(txtHeightFirst)-0.005;						
						if not isEveryAlone then							
							DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw = DisplayOverviewHud.settings.draw.width.animals[drawAnimalType[a].animalName].isDraw+1;
						end;
					end;
				end;
			end;
		end;		
	end;
	function foreignAnimalsHud(pos)
		--dito					
	end;	
	function getFixPosX(pos, animalName)		
		local fixPosX = 0;
		if #DisplayOverviewHud.settings.draw.sequenceSplit > 0 then			
			local isAnimalsWidth = false;
			local isEveryAlone = DisplayOverviewHud.settings.draw.animalModusEveryAlone;
			for a=1, pos do	
				if DisplayOverviewHud.settings.draw.sequenceSplit[a] ~= nil and DisplayOverviewHud.settings.draw.width[DisplayOverviewHud.settings.draw.sequenceSplit[a].. "T"] ~= nil then
					if a <= pos then
						fixPosX = fixPosX+DisplayOverviewHud.settings.draw.width[DisplayOverviewHud.settings.draw.sequenceSplit[a].. "T"];
					end;
				elseif DisplayOverviewHud.settings.draw.sequenceSplit[a] ~= nil and string.find(DisplayOverviewHud.settings.draw.sequenceSplit[a], "animal") then
					local tempAnimalName = string.gsub(DisplayOverviewHud.settings.draw.sequenceSplit[a], "animal", ""):lower();					
					if a <= pos then
						if DisplayOverviewHud.settings.draw.animalModusSideBySide and DisplayOverviewHud.settings.draw.width.animals[tempAnimalName] ~= nil then
							fixPosX = fixPosX+DisplayOverviewHud.settings.draw.width.animals[tempAnimalName].sT+(DisplayOverviewHud.settings.draw.width.animals[tempAnimalName].nT*DisplayOverviewHud.settings.draw.width.animals[tempAnimalName].multiply);
						elseif not DisplayOverviewHud.settings.draw.animalModusSideBySide and animalName == nil and not isAnimalsWidth then
							isAnimalsWidth = true;
							fixPosX = fixPosX+DisplayOverviewHud.settings.draw.width.animalsST+(DisplayOverviewHud.settings.draw.width.animalsNT);
						elseif not DisplayOverviewHud.settings.draw.animalModusSideBySide and animalName ~= nil and DisplayOverviewHud.settings.draw.width.animals[animalName] ~= nil then
							isAnimalsWidth = true;							
							fixPosX = fixPosX+DisplayOverviewHud.settings.draw.width.animals[animalName].sT+(DisplayOverviewHud.settings.draw.width.animals[animalName].nT*DisplayOverviewHud.settings.draw.width.animals[animalName].multiply);
							
						end;
					end;										
				end;				
			end;			
		end;
		return fixPosX;
	end;	
	if #DisplayOverviewHud.settings.draw.sequenceSplit > 0 then
		fillTypesVirtual();
		local stringSplit = DisplayOverviewHud.settings.draw.sequenceSplit;		
		for a=1, #stringSplit do
			if stringSplit[a] ~= nil and string.len(stringSplit[a]) > 0 then
				local what = stringSplit[a];				
				if string.find(what, "animal") and not string.find(what, "foreignAnimalsHud") then if not isAnimalsDraw then animal(a, string.gsub(what, "animal", ""));end;else loadstring(what.."(".. a..")")();end;				
			end;
		end;
	end;
end;

function DisplayOverviewHud:resetWidthHeightT()
	DisplayOverviewHud.settings.draw.width.amountsT = 0;
	DisplayOverviewHud.settings.draw.width.fillTypesT = 0;
	DisplayOverviewHud.settings.draw.width.stationsT = 0;
	DisplayOverviewHud.settings.draw.width.bestPricesT = 0;
	DisplayOverviewHud.settings.draw.width.animalsNT = 0;
	DisplayOverviewHud.settings.draw.width.animalsST = 0;
	DisplayOverviewHud.settings.draw.width.animals = {};		
	DisplayOverviewHud.settings.draw.height.animals = {};
	DisplayOverviewHud.settings.draw.width.foreignAnimalsHudT = 0;
	DisplayOverviewHud.settings.draw.height.maxT = 0;
end;

function DisplayOverviewHud:getDrawModus(sequence, isGreatDemands, isResetHeightFirst)	
	function resetFirstHeight()
		DisplayOverviewHud.settings.draw.height.first = 0;
	end;
	function getGreatDemands()		
		DisplayOverviewHud:setGreatDemand();
	end;
	if isResetHeightFirst then resetFirstHeight();end;
	if isGreatDemands then getGreatDemands();end;
	local size = DisplayOverviewHud.settings.size;
	local txtHeightFirst = DisplayOverviewHud.settings.draw.height.first;
	local heightDistance = getTextHeight(size, "Ä_")/2;	
	local widthDif = DisplayOverviewHud.settings.draw.widthDif;	
	function fillTypesVirtual()
		for key,descFruit in pairs (DisplayOverviewHud.fillTypes) do
			local desc = g_fillTypeManager.fillTypes[key];
			if desc ~= nil and DisplayOverviewHud.fillTypes[desc.index] ~= nil then	
				--reset
				DisplayOverviewHud.fillTypes[desc.index].isDraw = false;
				DisplayOverviewHud.fillTypes[desc.index].drawPosY = nil;				
				DisplayOverviewHud.fillTypes[desc.index].bestPrice = 0;
				DisplayOverviewHud.fillTypes[desc.index].bestPriceStation = "";
				DisplayOverviewHud.fillTypes[desc.index].isSellStation = false;
				--reset
			end;
		end;	
	end;
	function amountsVirtual()
		local maxHeight = 0;
		for key,storage in pairs(DisplayOverviewHud.storages) do
			local storageObject = storage.object.storages[1];		
			if storageObject ~= nil and (storage.object.ownerFarmId == 0 or storage.object.ownerFarmId == g_currentMission.player.farmId) then
				for fillType,isAccepted in pairs(storageObject.fillTypes) do
					if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil then
						DisplayOverviewHud.fillTypes[fillType].amount = Utils.getNoNil(storageObject.fillLevels[fillType]);
						if drawAmountFillType[fillType] == nil then drawAmountFillType[fillType] = {amount=0};end;
						drawAmountFillType[fillType].amount = drawAmountFillType[fillType].amount+Utils.getNoNil(storageObject.fillLevels[fillType], 0);
					end;
				end;
			end;
		end;		
		if DisplayOverviewHud.settings.draw.height.maxT < maxHeight then DisplayOverviewHud.settings.draw.height.maxT = maxHeight;end;
	end;
	function amounts()
		local maxHeight = 0;
		for key,storage in pairs(DisplayOverviewHud.storages) do
			local storageObject = storage.object.storages[1];		
			if storageObject ~= nil and (storage.object.ownerFarmId == 0 or storage.object.ownerFarmId == g_currentMission.player.farmId) then			
				for fillType,isAccepted in pairs(storageObject.fillTypes) do
					if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil then
						DisplayOverviewHud.fillTypes[fillType].amount = Utils.getNoNil(storageObject.fillLevels[fillType]);
						if drawAmountFillType[fillType] == nil then drawAmountFillType[fillType] = {amount=0};end;
						drawAmountFillType[fillType].amount = drawAmountFillType[fillType].amount+Utils.getNoNil(storageObject.fillLevels[fillType], 0);
						local amount = string.format("%1.0f", "".. drawAmountFillType[fillType].amount);
						local amountWidthTemp = getTextWidth(size, tostring(amount))+widthDif;
						if DisplayOverviewHud.settings.draw.width.amountsT < amountWidthTemp then DisplayOverviewHud.settings.draw.width.amountsT = amountWidthTemp;end;
						local txtHeight = getTextHeight(size, amount)+heightDistance;
						if txtHeightFirst == 0 then txtHeightFirst = txtHeight*2;end;
						--maxHeight = maxHeight+txtHeight;
					end;
				end;
			end;
		end;		
		if DisplayOverviewHud.settings.draw.height.maxT < maxHeight then DisplayOverviewHud.settings.draw.height.maxT = maxHeight;end;
	end;
	function fillTypes()		
		DisplayOverviewHud.settings.draw.height.fillTypesT = 0;		
		local maxFillNameLength = DisplayOverviewHud.settings.draw.maxFillNameLength;		
		--local txtHeightFirst = 0;
		local maxHeight = 0;
		for key,descFruit in pairs (DisplayOverviewHud.fillTypes) do
			local desc = g_fillTypeManager.fillTypes[key];
			if desc ~= nil and DisplayOverviewHud.fillTypes[desc.index] ~= nil then
				local fruitName = tostring(DisplayOverviewHud.fillTypes[desc.index].fruitName);
				drawFillTypeName[#drawFillTypeName+1] = {};
				if string.len(fruitName) > maxFillNameLength+2 then fruitName = getMaxNameLength(fruitName, maxFillNameLength);end; -- +2 for ..				
				drawFillTypeName[#drawFillTypeName].txt = fruitName;					
				DisplayOverviewHud.fillTypes[desc.index].drawTxt = fruitName;
				local txtHeight = getTextHeight(size, fruitName)+heightDistance;					
				local txtWidth = getTextWidth(size, fruitName)+widthDif;
				DisplayOverviewHud.fillTypes[desc.index].drawTxtHeight = txtHeight;
				drawFillTypeName[#drawFillTypeName].txtColor = DisplayOverviewHud.color.txtFillType;
				if DisplayOverviewHud.greatDemandFillTypes ~= nil and DisplayOverviewHud.greatDemandFillTypes[desc.index] ~= nil then drawFillTypeName[#drawFillTypeName].txtColor = DisplayOverviewHud.color.greatDemand;end;
				drawFillTypeName[#drawFillTypeName].txtHeight = txtHeight;
				drawFillTypeName[#drawFillTypeName].txtWidth = txtWidth;
				drawFillTypeName[#drawFillTypeName].descIndex = desc.index;				
				if DisplayOverviewHud.settings.draw.width.fillTypesT < txtWidth then DisplayOverviewHud.settings.draw.width.fillTypesT = txtWidth;end;
				if txtHeightFirst == 0 then txtHeightFirst = txtHeight*2;end; --better distance for fillTypes and stations (Money Box)				
				maxHeight = maxHeight+txtHeight;				
			end;			
		end;
		if DisplayOverviewHud.settings.draw.height.maxT < maxHeight then DisplayOverviewHud.settings.draw.height.maxT = maxHeight;end;
	end;		
	function stations()		
		local minStationNameLength = DisplayOverviewHud.settings.draw.minStationNameLength;
		local maxStationNameLength = DisplayOverviewHud.settings.draw.maxStationNameLength;
		local maxHeight = 0;		
		for key,station in pairs(DisplayOverviewHud.sellStations) do
			if (station.appearsOnStats and DisplayOverviewHud.settings.onlyAppearsOnStats) or not DisplayOverviewHud.settings.onlyAppearsOnStats then
				local stationName = tostring(station.name);
				if string.len(stationName) < minStationNameLength then stationName = getMinNameLength(stationName, minStationNameLength);end;
				if string.len(stationName) > maxStationNameLength+2 then stationName = getMaxNameLength(stationName, maxStationNameLength);end; -- +2 for ..
				drawStationName[#drawStationName+1] = {};
				drawStationName[#drawStationName].txt = stationName;
				drawStationName[#drawStationName].txtColor = DisplayOverviewHud.color.txtStation;
				if DisplayOverviewHud.greatDemand ~= nil and DisplayOverviewHud.greatDemand[station.name] ~= nil then drawStationName[#drawStationName].txtColor = DisplayOverviewHud.color.greatDemand;end;
				local txtHeight = getTextHeight(size, stationName)+heightDistance;
				if txtHeightFirst == 0 then txtHeightFirst = txtHeight*2;end;
				drawStationName[#drawStationName].txtHeight = txtHeight;
				local txtWidth = getTextWidth(size, stationName)+(widthDif*2);
				drawStationName[#drawStationName].txtWidth = txtWidth;
				drawStationName[#drawStationName].descIndex = station.posOnTable;
				DisplayOverviewHud.settings.draw.width.stationsT = DisplayOverviewHud.settings.draw.width.stationsT+txtWidth;
				local sellingStation = DisplayOverviewHud.sellStations[station.posOnTable].object.sellingStation;
				if sellingStation ~= nil then
					for fillType,isAccepted in pairs(sellingStation.acceptedFillTypes) do
						if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil then									
							DisplayOverviewHud.fillTypes[fillType].isSellStation = true;
							local difficultyMultiplier = 1000;
							local multiplier = getMultiplier(); --math.exp(-3.5 * (ageMultiplier+operatingTimeMultiplier)), EconomyManager.PRICE_MULTIPLIER[g_currentMission.missionInfo.difficulty], math.max(2 * (3 - g_currentMission.missionInfo.difficulty), 1);
							local pricePerLiter = ((sellingStation.fillTypePrices[fillType]+sellingStation.fillTypePriceRandomDelta[fillType])*sellingStation.priceMultipliers[fillType]*multiplier)*difficultyMultiplier; 
							if pricePerLiter > 	DisplayOverviewHud.fillTypes[fillType].bestPrice then 
								local txtWidthBestPriceStation = getTextWidth(size, stationName)+(widthDif*2);
								if DisplayOverviewHud.settings.draw.width.bestPricesT < txtWidthBestPriceStation then DisplayOverviewHud.settings.draw.width.bestPricesT = txtWidthBestPriceStation;end;
								DisplayOverviewHud.fillTypes[fillType].bestPrice = pricePerLiter;
								DisplayOverviewHud.fillTypes[fillType].bestPriceStation = tostring(stationName);
							end;														
						end;
					end;
				end;
				maxHeight = maxHeight+txtHeight; --later check better max height
			end;
		end;
		if DisplayOverviewHud.settings.draw.height.maxT < maxHeight then DisplayOverviewHud.settings.draw.height.maxT = maxHeight;end;
	end;
	function bestPrices()		
		if string.find(sequence, "stations") then return;end;
		local minStationNameLength = DisplayOverviewHud.settings.draw.minStationNameLength;
		local maxStationNameLength = DisplayOverviewHud.settings.draw.maxStationNameLength;
		local maxHeight = 0;
		for key,station in pairs(DisplayOverviewHud.sellStations) do
			if (station.appearsOnStats and DisplayOverviewHud.settings.onlyAppearsOnStats) or not DisplayOverviewHud.settings.onlyAppearsOnStats then
				local stationName = tostring(station.name);
				if string.len(stationName) < minStationNameLength then stationName = getMinNameLength(stationName, minStationNameLength);end;
				if string.len(stationName) > maxStationNameLength+2 then stationName = getMaxNameLength(stationName, maxStationNameLength);end; -- +2 for ..				
				local txtHeight = getTextHeight(size, stationName)+heightDistance;
				if txtHeightFirst == 0 then txtHeightFirst = txtHeight*2;end;				
				local txtWidth = getTextWidth(size, stationName)+(widthDif*2);								
				if DisplayOverviewHud.settings.draw.width.bestPricesT < txtWidth then DisplayOverviewHud.settings.draw.width.bestPricesT = txtWidth;end;
				local sellingStation = DisplayOverviewHud.sellStations[station.posOnTable].object.sellingStation;
				if sellingStation ~= nil then
					for fillType,isAccepted in pairs(sellingStation.acceptedFillTypes) do
						if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil then
							local difficultyMultiplier = 1000;
							local multiplier = getMultiplier();
							local pricePerLiter = ((sellingStation.fillTypePrices[fillType]+sellingStation.fillTypePriceRandomDelta[fillType])*sellingStation.priceMultipliers[fillType]*multiplier)*difficultyMultiplier;
							if pricePerLiter > 	DisplayOverviewHud.fillTypes[fillType].bestPrice then 
								DisplayOverviewHud.fillTypes[fillType].bestPrice = pricePerLiter;
								DisplayOverviewHud.fillTypes[fillType].bestPriceStation = tostring(stationName);
							end;														
						end;
					end;
				end;
				maxHeight = maxHeight+txtHeight;
			end;
		end;
		if DisplayOverviewHud.settings.draw.height.maxT < maxHeight then DisplayOverviewHud.settings.draw.height.maxT = maxHeight;end;
	end;
	function animal(pos)
		if g_currentMission.husbandries ~= nil then
			local animalType = string.gsub(DisplayOverviewHud.settings.draw.sequenceSplit[pos], "animal", "");
			local txtHeight = DisplayOverviewHud:animalsModul(animalType);
			if txtHeightFirst == 0 then txtHeightFirst = txtHeight*2;end;
		end;
	end;
	function foreignAnimalsHud()
		if DisplayOverviewHud.settings.isForeignAnimalsHud and DisplayOverviewHud.settings.supportForAnimalsHud then
			if g_currentMission.husbandries ~= nil then
				for key, animal in pairs(g_currentMission.husbandries) do
					if key ~= nil and animal ~= nil then
						local animalName = animal.modulesByName.animals.animalType:lower();
						if animalName == "sheep" and DisplayOverviewHud.settings.foreignAnimalsHud.animalsSheepHudActive or
						animalName == "pig" and DisplayOverviewHud.settings.foreignAnimalsHud.animalsPigHudActive or
						animalName == "cow" and DisplayOverviewHud.settings.foreignAnimalsHud.animalsCowHudActive or
						animalName == "chicken" and DisplayOverviewHud.settings.foreignAnimalsHud.animalsChickenHudActive or
						animalName == "horse" and DisplayOverviewHud.settings.foreignAnimalsHud.animalsHorseHudActive then
						DisplayOverviewHud.settings.draw.width.foreignAnimalsHudT = 1.0-DisplayOverviewHud.settings.foreignAnimalsHud.posX+(widthDif);end;
					end;
				end;
			end;
		end;
	end;
	if not DisplayOverviewHud.settings.firstCheckForeignAnimalsHudValues and DisplayOverviewHud.settings.isForeignAnimalsHud and DisplayOverviewHud.settings.supportForAnimalsHud then checkForeignAnimalsHudValues();end;
	if sequence then		
		--if not string.find(sequence, "foreignAnimalsHud") then foreignAnimalsHud();end;		
		searchItems(string.find(sequence, "animal") or string.find(sequence, "amounts"), string.find(sequence, "amounts"));
		fillTypesVirtual();		
		local stringSplit, isOkay = DisplayOverviewHud:get_hl("stringSplit", {sequence, " "}, "stringSplit sequence draw");
		if isOkay and #stringSplit > 0 then			
			DisplayOverviewHud.settings.draw.sequenceSplit = stringSplit;
			for a=1, #stringSplit do
				if stringSplit[a] ~= nil and string.len(stringSplit[a]) > 0 then
					local what = stringSplit[a];					
					if string.find(what, "animal") and not string.find(what, "foreignAnimalsHud") then animal(a);else loadstring(what.."()")();end;					
				end;
			end;
		end;
		if not string.find(sequence, "amounts") then amountsVirtual();end;
	end;
	DisplayOverviewHud.settings.draw.height.first = txtHeightFirst;
end;

function DisplayOverviewHud:deleteOverlays()
	if DisplayOverviewHud.overlays ~= nil then		
		for _index,v in pairs (DisplayOverviewHud.overlays) do
			local overlay = DisplayOverviewHud.overlays[_index];
			if overlay ~= nil and overlay and overlay.overlayId ~= nil and overlay.overlayId then
				overlay:delete();
				overlay = nil;
			end;
		end;
	end;
end;

function DisplayOverviewHud:setGetOverlaysDesign()
	DisplayOverviewHud.icon = {		
		ground   	= {  0+0.3, 16-0.3, 16-0.3, 0+0.3};
		equal   	= { 16+0.3, 16-0.3, 32-0.3, 0+0.3};
		down   		= { 32+0.3, 16-0.3, 48-0.3, 0+0.3};
		up   		= { 48+0.3, 16-0.3, 64-0.3, 0+0.3};
	};
	local iconFilePath = Utils.getFilename("design.dds", DisplayOverviewHud.modDir);	
	if iconFilePath == nil then return false;end;
	DisplayOverviewHud.overlays["priceEqual"] = Overlay:new(iconFilePath, 0, 0, DisplayOverviewHud.settings.draw.buttonGfxWidth1*1, DisplayOverviewHud.settings.draw.buttonGfxHeight1*1);
	DisplayOverviewHud:setOverlayUVsPx(DisplayOverviewHud.overlays["priceEqual"], DisplayOverviewHud.icon["equal"], 64, 64);
	local _,isOkay1 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["priceEqual"], {1, 1, 1, 1}}, "setBackgroundColor priceEqual");
	DisplayOverviewHud.overlays["priceUp"] = Overlay:new(iconFilePath, 0, 0, DisplayOverviewHud.settings.draw.buttonGfxWidth1*1, DisplayOverviewHud.settings.draw.buttonGfxHeight1*1);
	DisplayOverviewHud:setOverlayUVsPx(DisplayOverviewHud.overlays["priceUp"], DisplayOverviewHud.icon["up"], 64, 64);
	local _,isOkay2 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["priceUp"], {unpack(DisplayOverviewHud.color.bestPriceUp)}}, "setBackgroundColor priceUp");
	DisplayOverviewHud.overlays["priceDown"] = Overlay:new(iconFilePath, 0, 0, DisplayOverviewHud.settings.draw.buttonGfxWidth1*1, DisplayOverviewHud.settings.draw.buttonGfxHeight1*1);
	DisplayOverviewHud:setOverlayUVsPx(DisplayOverviewHud.overlays["priceDown"], DisplayOverviewHud.icon["down"], 64, 64);
	local _,isOkay3 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["priceDown"], {unpack(DisplayOverviewHud.color.bestPriceDown)}}, "setBackgroundColor priceDown");
	return isOkay1 and isOkay2 and isOkay3;
end;

function DisplayOverviewHud:setOverlayUVsPx(overlay, UVs, textureSizeX, textureSizeY)	
	if overlay.overlayId and overlay.currentUVs == nil or overlay.currentUVs ~= UVs then
		local leftX, bottomY, rightX, topY = unpack(UVs);
		local fromTop = false;
		if topY < bottomY then
			fromTop = true;
		end;
		local leftXNormal = leftX / textureSizeX;
		local rightXNormal = rightX / textureSizeX;
		local bottomYNormal = bottomY / textureSizeY;
		local topYNormal = topY / textureSizeY;
		if fromTop then
			bottomYNormal = 1 - bottomYNormal;
			topYNormal = 1 - topYNormal;
		end;
		setOverlayUVs(overlay.overlayId, leftXNormal,bottomYNormal, leftXNormal,topYNormal, rightXNormal,bottomYNormal, rightXNormal,topYNormal);		
		overlay.currentUVs = UVs;
	end;
end;

---test for vanish lines
function DisplayOverviewHud:setLineOverReference(self, reference, line, fat, up, down, left, right, widthHalf, proLineH, proLineV, heightH, heightV)
	if reference ~= nil and line ~= nil and reference.overlayId ~= nil and line.overlayId ~= nil then
	end;
end;
---test for vanish lines

function getMinNameLength(name, minLen)
	local newName = name;
	local i = 0;
	local first = false;
	while minLen > string.len(newName) do
		i = i + 1;
		if first then newName = " ".. newName;first = false;
		else newName = newName.. " ";first = true;end;
	end
	return newName;
end;

function getMaxNameLength(name, maxLen)				
	return string.sub(name, 0, maxLen).. "..";
end;

function getLineAsString(size, width)	
	local lineString = "";
	local lineStringWidth = 0;
	local i = 0;	
	while width > lineStringWidth do
		i = i + 1;
		lineString = lineString.. "_";
		lineStringWidth = getTextWidth(size, lineString);
	end;
	--if getTextWidth(size, lineString) > width then lineString = string.sub(lineString, 0 ,string.len(lineString)-1);end;
	return lineString;
end;

function DisplayOverviewHud:getRightPosY()				
	--check getIsVisible()
	local side = g_currentMission.hud.sideNotifications.overlay.y;
	local top = g_currentMission.hud.topNotification.overlay.y;
	if top > 1.0 and side > 1.0 then return DisplayOverviewHud.inGameDisplays.rightUpDisplay.moneyBox.overlay.y;end;
	return math.min(side, top);
end;

function DisplayOverviewHud:getTableCopy(t)
	function table.copy(t)
		local t2 = {};
		for k,v in pairs(t) do
			if type(v) == "table" then
				t2[k] = table.copy(v);
			else
				t2[k] = v;
			end;
		end;
		return t2;
	end;
	return table.copy(t);
end;

function searchForeignMods()
	DisplayOverviewHud.settings.isForeignAnimalsHud = g_modIsLoaded.animalsHud ~= nil and g_modIsLoaded.animalsHud;
	local env = getfenv(0);
	if DisplayOverviewHud.settings.isForeignAnimalsHud then		
		DisplayOverviewHud.settings.foreignAnimalsHud = env["animalsHud"].animalsHud;
		DisplayOverviewHud.settings.foreignAnimalsHudDefault = env["animalsHud"].animalsHud;		
	else
		print("---Info ".. tostring(DisplayOverviewHud.metadata.title).. " --> Support for foreign AnimalsHud Mod is not ready (not found Mod)---")
	end;
end;

function searchItems(animal, bale)
	if animal then
		for key, value in pairs (g_currentMission.ownedItems) do
			if key ~= nil and value ~= nil and value.items ~= nil and type(value.items) == "table" then			
				for _, item in pairs(value.items) do				
					if item ~= nil and type(item) == "table" and item.typeName ~= nil and (string.find(item.typeName:lower(), "pallet")) and item.ownerFarmId == g_currentMission.player.farmId then
						if item.spec_fillUnit ~= nil and item.spec_fillUnit.fillUnits ~= nil and item.spec_fillUnit.fillUnits[1] ~= nil and item.spec_fillUnit.fillUnits[1].fillType ~= nil then
							local fillType = item.spec_fillUnit.fillUnits[1].fillType;						
							if item.spec_fillUnit.fillUnits[1].fillLevel == item.spec_fillUnit.fillUnits[1].capacity then
								if drawAmountsItems[fillType] == nil then drawAmountsItems[fillType] = {};end;
								drawAmountsItems[fillType][#drawAmountsItems[fillType]+1] = {};
								local x0,y0,z0 = getWorldTranslation(item.rootNode);
								drawAmountsItems[fillType][#drawAmountsItems[fillType]].x = x0;drawAmountsItems[fillType][#drawAmountsItems[fillType]].y = y0;drawAmountsItems[fillType][#drawAmountsItems[fillType]].z = z0;
								if drawAmountFillType[fillType] == nil then drawAmountFillType[fillType] = {amount=Utils.getNoNil(value.numItems, 0)};end;
							end;
						end;							
					end;
				end;
			end;
		end;
	end;
	if bale and DisplayOverviewHud.bale.round > 0 and DisplayOverviewHud.bale.square > 0 then
		for key,value in pairs(g_currentMission.itemsToSave) do
			if value ~= nil and value.className ~= nil and value.className == "Bale" and value.item ~= nil and value.item.ownerFarmId == g_currentMission.player.farmId then
				if string.find(value.item.i3dFilename:lower(), "roundbale") then
					if drawAmountFillType[DisplayOverviewHud.bale.round] == nil then drawAmountFillType[DisplayOverviewHud.bale.round] = {amount=1};else
						drawAmountFillType[DisplayOverviewHud.bale.round].amount = drawAmountFillType[DisplayOverviewHud.bale.round].amount+1;end;
				elseif string.find(value.item.i3dFilename:lower(), "squarebale") then
					if drawAmountFillType[DisplayOverviewHud.bale.square] == nil then drawAmountFillType[DisplayOverviewHud.bale.square] = {amount=1};else
						drawAmountFillType[DisplayOverviewHud.bale.square].amount = drawAmountFillType[DisplayOverviewHud.bale.square].amount+1;end;
				end;
			end;
		end;
	end;
end;

function checkForeignAnimalsHudValues()		
	function firstCheck(result)
		return result.posX2 ~= nil and result.posX ~= nil;
		--return result.posX2 ~= nil and result.posX ~= nil and result.posY ~= nil and result.animalsChickenHudActive ~= nil and result.animalsHorseHudActive ~= nil and result.animalsPigHudActive ~= nil
		--and result.animalsCowHudActive ~= nil and result.animalsSheepHudActive ~= nil and result.paddingBetweenLines ~= nil and result.linePadding ~= nil and result.fontSize ~= nil;
	end;	
	DisplayOverviewHud.settings.isForeignAnimalsHud = firstCheck(DisplayOverviewHud.settings.foreignAnimalsHud);
	DisplayOverviewHud.settings.firstCheckForeignAnimalsHudValues = true;
	if not DisplayOverviewHud.settings.isForeignAnimalsHud then 
		print("---Info ".. tostring(DisplayOverviewHud.metadata.title).. " --> Support for foreign AnimalsHud Mod is not ready (not correctly Version)---");
		g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_CRITICAL, "DOHud Info: foreign AnimalsHud Support disabled(see log.txt)", "DOmodus");
	else
		print("---Info ".. tostring(DisplayOverviewHud.metadata.title).. " --> Optional Support for foreign AnimalsHud Mod is ready (displayOverviewHudSettings.xml)---")
	end;	
end;

function isServer()
	return g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo ~= nil;
end;

function isMp()
	if DisplayOverviewHud.isLoadMap then return g_currentMission.missionDynamicInfo.isMultiplayer;end;
	return false;
end;

function isHostMp()
	return isMp() and g_server ~= nil and g_client ~= nil and g_dedicatedServerInfo == nil;
end;

function getMultiplier()
	if isMp() and not isHostMp() then return 1 else return EconomyManager.getPriceMultiplier();end;
end;

function DisplayOverviewHud:round(n, precision)
	if precision and precision > 0 then
		return math.floor((n * math.pow(10, precision)) + 0.5) / math.pow(10, precision);
	end;
	return math.floor(n + 0.5);
end;

local targetAspectRatio = 16/9;
local aspectRatioRatio = g_screenAspectRatio / targetAspectRatio;
local sizeRatio = 1;
if g_screenWidth >= 1920 then
	sizeRatio = 1920 / g_screenWidth;
elseif g_screenWidth < 1920 then
	sizeRatio = math.max((1920 / g_screenWidth) * 0.75, 1);
end;

function DisplayOverviewHud:getFullPx(n, dimension)
	if dimension == 'x' then
		return DisplayOverviewHud:round(n * g_screenWidth) / g_screenWidth;
	else
		return DisplayOverviewHud:round(n * g_screenHeight) / g_screenHeight;
	end;
end;

function DisplayOverviewHud:pxToNormal(px, dimension, fullPixel)
	local ret;
	if dimension == 'x' then
		ret = (px / 1920) * sizeRatio;
		--ret = (px / g_screenWidth) * sizeRatio;
	else
		ret = (px / 1080) * sizeRatio * aspectRatioRatio;
		--ret = (px / g_screenHeight) * sizeRatio * aspectRatioRatio;
	end;
	if fullPixel == nil or fullPixel then
		ret = DisplayOverviewHud:getFullPx(ret, dimension);
	end;
	return ret;
end;

function getInGameDisplays()
	for key, value in pairs(g_currentMission.hud.displayComponents) do
		if g_currentMission.hud.displayComponents[key].showTime ~= nil then			
			DisplayOverviewHud.inGameDisplays.rightUpDisplay = g_currentMission.hud.displayComponents[key];
			break;
		end;
	end;	
end;

function DisplayOverviewHud:setGreatDemand()				
	DisplayOverviewHud.greatDemand = nil;	
	DisplayOverviewHud.greatDemandFillTypes = nil;	
	local demandSales = g_currentMission.economyManager;
	if demandSales ~= nil and demandSales.numberOfConcurrentDemands ~= nil and demandSales.numberOfConcurrentDemands > 0 then
		for a=1, demandSales.numberOfConcurrentDemands do
			if demandSales.greatDemands ~= nil and demandSales.greatDemands[a].isRunning and demandSales.greatDemands[a].isValid then
				if demandSales.greatDemands[a].sellStation.stationName ~= nil then
					local stationName = demandSales.greatDemands[a].sellStation.stationName;					
					if DisplayOverviewHud.greatDemand == nil then DisplayOverviewHud.greatDemand = {};end;
					DisplayOverviewHud.greatDemand[stationName] = {};
					DisplayOverviewHud.greatDemand[stationName].fillType = demandSales.greatDemands[a].fillTypeIndex;
					DisplayOverviewHud.greatDemand[stationName].multiplier = demandSales.greatDemands[a].demandMultiplier;
					DisplayOverviewHud.greatDemand[stationName].demandDuration = demandSales.greatDemands[a].demandDuration;
					if DisplayOverviewHud.greatDemandFillTypes == nil then DisplayOverviewHud.greatDemandFillTypes = {};end;					
					DisplayOverviewHud.greatDemandFillTypes[demandSales.greatDemands[a].fillTypeIndex] = {};
					DisplayOverviewHud.greatDemandFillTypes[demandSales.greatDemands[a].fillTypeIndex].multiplier = demandSales.greatDemands[a].demandMultiplier;
					DisplayOverviewHud.greatDemandFillTypes[demandSales.greatDemands[a].fillTypeIndex].stationName = stationName;					
				end;
			end;
		end;
	end;
end;

function DisplayOverviewHud:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if DisplayOverviewHud.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" and g_currentMission.hl[args] ~= nil then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if DisplayOverviewHud.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if DisplayOverviewHud.hlDebugMode and (not isOkay or foundArgsError) then DisplayOverviewHud:setDebug("DisplayOverviewHudMod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;

function DisplayOverviewHud:setDebug(argsMod, args1, errorTxt, args2, args3)	
	if g_currentMission.hl.debug == nil then g_currentMission.hl.debug = {};end;
	if g_currentMission.hl.debug[argsMod] == nil then g_currentMission.hl.debug[argsMod] = {};end;
	local errorString = "Trigger: ".. tostring(args1).. " -errorTxtCall: ".. tostring(errorTxt).. " -argsError: ".. tostring(args2).. " -resultError: ".. tostring(args3);
	local alreadyExists = false;
	if #g_currentMission.hl.debug[argsMod] == 0 then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));else
		for key,value in pairs(g_currentMission.hl.debug[argsMod]) do			
			if tostring(value) == errorString and string.len(value) == string.len(errorString) then alreadyExists=true;break;end;			
		end;		
		if not alreadyExists then table.insert(g_currentMission.hl.debug[argsMod], tostring(errorString));end;
	end;	
end;

function DisplayOverviewHud:loadOverlays()
	DisplayOverviewHud.overlays = {};
	local _,isOkay1 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "groundFillTypes"}, "getSetDefaultBackground FillTypes");
	local _,isOkay2 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "groundStations"}, "getSetDefaultBackground Stations");	
	local _,isOkay3 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "groundAmounts"}, "getSetDefaultBackground Amounts");	
	local _,isOkay4 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "lineFillTypes"}, "getSetDefaultBackground Line FillTypes");
	local _,isOkay5 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "lineStations"}, "getSetDefaultBackground Line Stations");
	local _,isOkay6 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "lineAmounts"}, "getSetDefaultBackground Line Amounts");
	local _,isOkay9 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "lineBestPrices"}, "getSetDefaultBackground Line BestPrices");
	local _,isOkay10 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "groundBestPrices"}, "getSetDefaultBackground BestPrices");
	local _,isOkay11 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "groundAnimals"}, "getSetDefaultBackground Animals");
	local _,isOkay12 = DisplayOverviewHud:get_hl("getSetDefaultBackground", {DisplayOverviewHud.overlays, "lineAnimals"}, "getSetDefaultBackground Line Animals");
	local isOkay7 = DisplayOverviewHud:loadResetOverlayColor(false);
	local isOkay8 = DisplayOverviewHud:setGetOverlaysDesign();
	return isOkay1 and isOkay2 and isOkay3 and isOkay4 and isOkay5 and isOkay6 and isOkay7 and isOkay8 and isOkay9 and isOkay10 and isOkay11 and isOkay12;
end;

function DisplayOverviewHud:loadResetOverlayColor(isReset)
	local _,isOkay1 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["lineStations"], DisplayOverviewHud.color.lineStations}, "setBackgroundLineColor Line Stations");
	local _,isOkay2 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["groundFillTypes"], DisplayOverviewHud.color.backgroundFillTypes}, "setBackgroundColor FillTypes");
	local _,isOkay3 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["groundAmounts"], DisplayOverviewHud.color.backgroundAmounts}, "setBackgroundColor Amounts");
	local _,isOkay4 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["groundStations"], DisplayOverviewHud.color.backgroundStations}, "setBackgroundColor Stations");
	local _,isOkay5 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["lineFillTypes"], DisplayOverviewHud.color.lineFillTypes}, "setBackgroundLineColor Line FillTypes");
	local _,isOkay6 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["lineAmounts"], DisplayOverviewHud.color.lineAmounts}, "setBackgroundLineColor Line Amounts");
	local _,isOkay7 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["lineBestPrices"], DisplayOverviewHud.color.lineBestPrices}, "setBackgroundLineColor Line BestPrices");
	local _,isOkay8 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["groundBestPrices"], DisplayOverviewHud.color.backgroundBestPrices}, "setBackgroundLineColor BestPrices");
	local _,isOkay11 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["lineAnimals"], DisplayOverviewHud.color.lineAnimals}, "setBackgroundLineColor Line Animals");
	local _,isOkay12 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["groundAnimals"], DisplayOverviewHud.color.backgroundAnimals}, "setBackgroundLineColor Animals");
	local reset = not isReset
	if isReset then
		local _,isOkay9 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["priceDown"], {unpack(DisplayOverviewHud.color.bestPriceDown)}}, "setBackgroundColor priceDown");
		local _,isOkay10 = DisplayOverviewHud:get_hl("setBackgroundColor", {DisplayOverviewHud.overlays["priceUp"], {unpack(DisplayOverviewHud.color.bestPriceUp)}}, "setBackgroundColor priceUp");
		if isOkay9 and isOkay10 then reset = true;end;
	end;
	return isOkay1 and isOkay2 and isOkay3 and isOkay4 and isOkay5 and isOkay6 and isOkay7 and isOkay8 and isOkay11 and isOkay12 and reset;
end;

function DisplayOverviewHud:loadFillTypes()
	DisplayOverviewHud.fillTypes = {};
	--local notFillTypesAnimals = {"horse_type", "cow_type", "sheep_type", "chicken_type", "pig_type"};	
	--local notFillTypes = {"unknown", "air", "def", "tarp", "treesaplings", "diesel", "fuel", "poplar", "weed"};	
	--local notFillExactNames = {"grass", "drygrass", "roundbale_drygrass", "roundbale_wheat", "roundbale_barley", "roundbale_grass", "squarebale_wheat", "squarebale_barley"};
	function isFillAnimals(descName)		
		for _,notFill in pairs(DisplayOverviewHud.settings.notDrawFillTypes.animals) do			
			if string.find(descName, notFill) then return true;end;
		end;
		return false;
	end;
	function isFillExactNames(descName)		
		for _,notFill in pairs(DisplayOverviewHud.settings.notDrawFillTypes.exactNames) do			
			if string.find(descName, notFill) then 
				if string.len(descName) == string.len(notFill) then return true;end;
			end;
		end;
		return false;
	end;
	function isFillDefault(descName)		
		for _,notFill in pairs(DisplayOverviewHud.settings.notDrawFillTypes.default) do			
			if string.find(descName, "_type") and isFillAnimals(descName) then return false;end;
			for _,notFillMaster in pairs(DisplayOverviewHud.settings.notDrawFillTypes.masterNameForExactNames) do	
				if string.find(descName, notFillMaster) and isFillExactNames(descName) then return false;end;
			end;
			if string.find(descName, notFill) then return false;end;
		end;
		return true;
	end;
	function isFillByUser(descName)
		for _,notFill in pairs(DisplayOverviewHud.settings.notDrawFillTypes.byUser) do			
			if string.find(descName, notFill) then return false;end;
		end;
		return true;
	end;
	
	for _,desc in pairs(g_currentMission.fillTypeManager.fillTypes) do		
		if desc ~= nil and desc.name ~= nil then
			local descName = tostring(string.lower(desc.name));						
			if descName == "roundbale" then DisplayOverviewHud.bale.round = desc.index;end;
			if descName == "squarebale" then DisplayOverviewHud.bale.square = desc.index;end;
			if isFillByUser(descName) and isFillDefault(descName) then
				DisplayOverviewHud.fillTypes[desc.index] = {};
				DisplayOverviewHud.fillTypes[desc.index].fruitName = desc.title;				
				DisplayOverviewHud.fillTypes[desc.index].descName = desc.name;				
				DisplayOverviewHud.fillTypes[desc.index].descIndex = desc.index;
				DisplayOverviewHud.fillTypes[desc.index].bestPrice = 0;
				DisplayOverviewHud.fillTypes[desc.index].bestPriceStation = "";
				DisplayOverviewHud.fillTypes[desc.index].isSellStation = false;
				--DisplayOverviewHud.fillTypes[desc.index].greatDemandStation = nil;
				--DisplayOverviewHud.fillTypes[desc.index].greatDemandMultiplier = 1;
				DisplayOverviewHud.fillTypes[desc.index].showOnPriceTable = desc.showOnPriceTable;
				DisplayOverviewHud.fillTypes[desc.index].pricePerLiter = Utils.getNoNil(desc.pricePerLiter, 0);
				DisplayOverviewHud.fillTypes[desc.index].previousHourPrice = Utils.getNoNil(desc.previousHourPrice, 0);				
				DisplayOverviewHud.fillTypes[desc.index].massPerLiter = Utils.getNoNil(desc.massPerLiter, 0);
				DisplayOverviewHud.fillTypes[desc.index].startPricePerLiter = Utils.getNoNil(desc.startPricePerLiter, 0);
				DisplayOverviewHud.fillTypes[desc.index].totalAmount = Utils.getNoNil(desc.totalAmount, 0);
				DisplayOverviewHud.fillTypes[desc.index].amount = 0;
			end;
		end;
	end;
end;

function DisplayOverviewHud:loadAnimales()
	DisplayOverviewHud.animals = {};
	if g_currentMission.husbandries ~= nil then
		for key, object in pairs(g_currentMission.husbandries) do
			if key ~= nil and object ~= nil then
				DisplayOverviewHud.animals[#DisplayOverviewHud.animals+1] = {};
				DisplayOverviewHud.animals[#DisplayOverviewHud.animals].object = object;
				DisplayOverviewHud.animals[#DisplayOverviewHud.animals].name = Utils.getNoNil(object.modulesByName.animals.animalType, "Unknown");
				DisplayOverviewHud.animals[#DisplayOverviewHud.animals].ownerFarmId = object.ownerFarmId;
			end;
		end;
	end;
end;

function DisplayOverviewHud:loadPlaceables()
	DisplayOverviewHud.sellStations = {};
	DisplayOverviewHud.otherStations = {}; --later
	DisplayOverviewHud.buyingStations = {}; --later
	DisplayOverviewHud.storages = {}; --check extension storage later
	DisplayOverviewHud.animalsStable = {}; --later
	DisplayOverviewHud.bgas = {}; --later
	DisplayOverviewHud.otherObjects = {};
	for a=1, #g_currentMission.placeables do
		if g_currentMission.placeables[a] ~= nil then
			local object = g_currentMission.placeables[a];
			if object ~= nil and object.nodeId ~= nil then
				if object.sellingStation ~= nil and type(object.sellingStation) == "table" and object.sellingStation.incomeName ~= nil then					
					if string.find(object.sellingStation.incomeName, "harvestIncome") then						
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations+1] = {};
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].object = object;
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].posOnTable = #DisplayOverviewHud.sellStations;
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].nodeId = object.nodeId;						
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].name = Utils.getNoNil(object.sellingStation.stationName, "Unknown");
						DisplayOverviewHud.sellStations[#DisplayOverviewHud.sellStations].appearsOnStats = Utils.getNoNil(object.sellingStation.appearsOnStats, false);						
					end;
				elseif object.buyingStation ~= nil and type(object.buyingStation) == "table" and object.buyingStation.incomeName ~= nil then
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations+1] = {};
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations].posOnTable = #DisplayOverviewHud.buyingStations;
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations].nodeId = object.nodeId;
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations].object = object;
					DisplayOverviewHud.buyingStations[#DisplayOverviewHud.buyingStations].name = Utils.getNoNil(object.buyingStation.stationName, "Unknown");					
				elseif object.storages ~= nil and type(object.storages) == "table" and object.loadingStation ~= nil and object.loadingStation.stationName ~= nil then
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages+1] = {};
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].posOnTable = #DisplayOverviewHud.storages;
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].nodeId = object.nodeId;
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].object = object;
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].ownerFarmId = object.storages[1].ownerFarmId;
					DisplayOverviewHud.storages[#DisplayOverviewHud.storages].name = Utils.getNoNil(object.loadingStation.stationName, "Unknown");
				elseif object.husbandryDirtyFlag ~= nil then
					DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable+1] = {};
					DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable].posOnTable = #DisplayOverviewHud.animalsStable;
					DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable].nodeId = object.nodeId;
					DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable].object = object;
					--DisplayOverviewHud.animalsStable[#DisplayOverviewHud.animalsStable].name = Utils.getNoNil(object.stationName, "Unknown");					
				elseif object.bunkerSilos ~= nil and object.bga ~= nil then
					DisplayOverviewHud.bgas[#DisplayOverviewHud.bgas+1] = {};
					DisplayOverviewHud.bgas[#DisplayOverviewHud.bgas].posOnTable = #DisplayOverviewHud.bgas;
					DisplayOverviewHud.bgas[#DisplayOverviewHud.bgas].nodeId = object.nodeId;
					DisplayOverviewHud.bgas[#DisplayOverviewHud.bgas].object = object;
				elseif object.stationName ~= nil then							
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations+1] = {};
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations].posOnTable = #DisplayOverviewHud.otherStations;
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations].nodeId = object.nodeId;
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations].object = object;
					DisplayOverviewHud.otherStations[#DisplayOverviewHud.otherStations].name = Utils.getNoNil(object.stationName, "Unknown");
				else
					DisplayOverviewHud.otherObjects[#DisplayOverviewHud.otherObjects+1] = {};
					DisplayOverviewHud.otherObjects[#DisplayOverviewHud.otherObjects].posOnTable = #DisplayOverviewHud.otherObjects;
					DisplayOverviewHud.otherObjects[#DisplayOverviewHud.otherObjects].nodeId = object.nodeId;
					DisplayOverviewHud.otherObjects[#DisplayOverviewHud.otherObjects].object = object;
				end;
			end;
		end;
	end;
end;

function DisplayOverviewHud:setGetStorages(ownerFarmId)	
	for key,storage in pairs(DisplayOverviewHud.storages) do
		local storageObject = storage.object.storages[1];		
		if storageObject ~= nil and (storage.object.ownerFarmId == 0 or storage.object.ownerFarmId == g_currentMission.player.farmId) then			
			for fillType,isAccepted in pairs(storageObject.fillTypes) do
				if isAccepted and DisplayOverviewHud.fillTypes[fillType] ~= nil then
					DisplayOverviewHud.fillTypes[fillType].amount = Utils.getNoNil(storageObject.fillLevels[fillType]);
					if drawAmountFillType[fillType] == nil then drawAmountFillType[fillType] = {amount=0};end;
					drawAmountFillType[fillType].amount = drawAmountFillType[fillType].amount+Utils.getNoNil(storageObject.fillLevels[fillType], 0);
					local amount = string.format("%1.0f", "".. drawAmountFillType[fillType].amount);
					local amountWidthTemp = getTextWidth(DisplayOverviewHud.settings.size, amount)+DisplayOverviewHud.settings.draw.widthDif;
					if DisplayOverviewHud.settings.draw.width.amountsT < amountWidthTemp then DisplayOverviewHud.settings.draw.width.amountsT = amountWidthTemp;end;
				end;
			end;
		end;
	end;
end;